/*******************************************************************************

   This sample ( CoAN-012.c by Continea SRL) is based on:
   	- Samples/RemoteProgramUpdate/upload_firmware.c
      - Samples/RCM5400W/TCPIP/browseled.c
 		 (Both are Copyright by Digi International)
   ----------------------------------------------------------------------------
	Application Note 421 contains full documentation on using the Remote Program
	Update library and samples.

	Demonstrate using the HTTP file upload feature and board_update.lib to
	update the system firmware.  Stores the firmware in a temporary location
   into the mass storage seria flash until upload is complete and verified.
   Location for the temp firmware was selected by BU_TEMP_USE_ macro inside
   the upld.lib library.

   The program is structured in three blocks:
   	-upld.lib: which contains the upload service.
      -iweb.lib: with the web interface of the user program.
      -iWeb folder: containing program's pages and the uploader firmware page.

   More information in next revision...
*******************************************************************************/
#class auto
#memmap xmem
#use RCM54xxW.lib

/***********************************
 * Configuration                   *
 * -------------                   *
 * All fields in this section must *
 * be altered to match your local  *
 * network settings.               *
 ***********************************/
#define TCPCONFIG 1
#define _PRIMARY_STATIC_IP 	"10.0.0.55"
#define _PRIMARY_NETMASK		"255.255.255.0"
#define MY_GATEWAY 				"10.0.0.1"

#define WIFI_USE_WPA  											//WPA support.
#define IFC_WIFI_ENCRYPTION   IFPARAM_WIFI_ENCR_TKIP  // cypher suite

#define IFC_WIFI_SSID               "cika-interno"        		//SSID
#define IFC_WIFI_WPA_PSK_PASSPHRASE "nomeacuerdo"   		//passphrase (1-63 chars)

// Required for this demo, to include upload code.
#define USE_HTTP_UPLOAD
// No name lookups required
#define DISABLE_DNS
// Define this because we are using a static rule table.
#define SSPEC_FLASHRULES
// Make use of RabbitWeb's scripting commands in HTML files
#define USE_RABBITWEB 1
// Only one server is really needed for the HTTP server as long as
// tcp_reserveport() is called on port 80.
#define HTTP_MAXSERVERS 1
// HTTP upload works better with a large buffer.  HTTP.LIB will xalloc
// HTTP_SOCK_BUF_SIZE bytes of xmem for each HTTP server socket
#define HTTP_SOCK_BUF_SIZE (12 * MAX_MTU)
// use DIGEST authentication (more secure than BASIC authentication)
#define USE_HTTP_DIGEST_AUTHENTICATION 1

#use "dcrtcp.lib"
#use "http.lib"
//Continea library for this demo
#use "upld.lib"
//Rabbit library
#use "board_update.lib"
//Continea library for this demo
#use "iweb.lib"

void main()
{
   //initialize board & user program variables for this demo
   brdInit();
   strcpy(led1,"ledon.gif");
   strcpy(led2,"ledoff.gif");

   // Start network and wait for interface to come up (or error exit).
	sock_init_or_exit(1);

 	iweb_init();
	upld_setup();

   http_init();
   tcp_reserveport(80);

   while (1)
   {
      http_handler();
      update_outputs();
#ifdef BU_TEMP_USE_FAT
      if (kbhit()) {
      	unmount_all();
         exit(0);
      }
#endif
   }
}


